Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 134491 - (metabug) USE-flag cleanup
Summary: (metabug) USE-flag cleanup
Status: CONFIRMED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: New packages (show other bugs)
Hardware: All Linux
: High normal (vote)
Assignee: Gentoo Quality Assurance Team
URL:
Whiteboard:
Keywords: Tracker
Depends on: 198901 94756 134493 134645 144534 148416 157265 158114 166759 177657 178128 202967
Blocks:
  Show dependency tree
 
Reported: 2006-05-27 03:17 UTC by Elias Probst
Modified: 2013-01-24 17:54 UTC (History)
5 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
unused local flags (unused_flag.log,4.05 KB, text/plain)
2006-09-09 05:08 UTC, Jakub Moc (RETIRED)
Details
unused local flags (updated) (unused_flag.log,2.13 KB, text/plain)
2006-09-10 03:45 UTC, Jakub Moc (RETIRED)
Details
unused local flags (updated again) (unused_flag.log,927 bytes, text/plain)
2006-09-17 04:50 UTC, Jakub Moc (RETIRED)
Details
Usage of global flags by unmasked packages (globals.tar.xz,57.08 KB, application/octet-stream)
2013-01-23 16:24 UTC, Roman Žilka
Details
Usage of local-only flags by packages (locals-that-are-not-global2,53.44 KB, text/plain)
2013-01-23 16:28 UTC, Roman Žilka
Details
Usage of global flags by unmasked packages (globals.tar.xz,58.55 KB, application/octet-stream)
2013-01-24 17:54 UTC, Roman Žilka
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Elias Probst 2006-05-27 03:17:24 UTC
Because of the huge number of USE-flags I think it's time to do a little cleanup....
Please help collecting "duplicates" and resolving USE-flags as in the bugs, this one depends on.
Comment 1 Jakub Moc (RETIRED) gentoo-dev 2006-09-09 05:08:33 UTC
Created attachment 96469 [details]
unused local flags
Comment 2 Jakub Moc (RETIRED) gentoo-dev 2006-09-09 05:17:15 UTC
CCing maintainers/herds, please pick up your stuff from the above list and clean up, thanks.
Comment 3 Christian Zoffoli (RETIRED) gentoo-dev 2006-09-09 06:39:26 UTC
magma-plugins fixed
Comment 4 Roy Marples (RETIRED) gentoo-dev 2006-09-09 07:32:20 UTC
dovecot fixed
Comment 5 Fabian Groffen gentoo-dev 2006-09-09 07:34:22 UTC
gnustep-base/gnustep-base: use.local.desc unused flag(s): libffi

thanks, I forgot this one indeed.
Comment 6 Diego Elio Pettenò (RETIRED) gentoo-dev 2006-09-09 07:53:03 UTC
kde, media-video, sound, bsd done.
Comment 7 Christian Heim (RETIRED) gentoo-dev 2006-09-09 11:33:48 UTC
The following useflags have been removed (thus fixed) from use.local.desc:

net-wireless/ipw2200: radiotap (myself)
net-wireless/ipw3945: radiotap (myself)
sys-apps/lm_sensors: rrdtool (myself)
sys-kernel/ck-sources: ck-plus (kernel)
sys-kernel/vserver-sources: ngnet (vserver-devs)
Comment 8 Donnie Berkholz (RETIRED) gentoo-dev 2006-09-09 12:23:13 UTC
xmerlin removed nogulm (sys-cluster/magma-plugins).

In the future, it would be more helpful if you could list by maintainer rather than package.
Comment 9 Bryan Østergaard (RETIRED) gentoo-dev 2006-09-09 16:18:14 UTC
Mozilla stuff cleaned up.
Comment 10 Andrew Ross (RETIRED) gentoo-dev 2006-09-09 16:26:47 UTC
xen fixed.
Comment 11 Michael Cummings (RETIRED) gentoo-dev 2006-09-09 16:38:41 UTC
mail-filter/spamassassin: use.local.desc unused flag(s): extramodules, pyzor, razor, spf

extramodules was taken care of when this was first mentioned on -dev, and the rest is still a false finding. The other three flags are still being used by one of the ebuilds for spamassassin. Fix your list :)

Comment 12 Michael Cummings (RETIRED) gentoo-dev 2006-09-09 18:47:46 UTC
(In reply to comment #11)
> extramodules was taken care of when this was first mentioned on -dev, and the
> rest is still a false finding. The other three flags are still being used by
> one of the ebuilds for spamassassin. Fix your list :)
> 
blame my reply on being up for 46 hours or something...use.local.desc looks fixed, taking perl off this list, sorry for the traffic
Comment 13 Leonardo Boshell (RETIRED) gentoo-dev 2006-09-09 22:27:57 UTC
Fixed app-misc/workrave flags
Comment 14 Jakub Moc (RETIRED) gentoo-dev 2006-09-10 03:45:15 UTC
Created attachment 96568 [details]
unused local flags (updated)

Attached an updated list to make search easier... ;)
Comment 15 Vlastimil Babka (Caster) (RETIRED) gentoo-dev 2006-09-10 04:00:16 UTC
Removed dev-java/ibm-jre-bin, dev-java/velocity and nogecko-sdk from dev-util/eclipse-sdk.
Comment 16 Stefan Schweizer (RETIRED) gentoo-dev 2006-09-10 04:11:41 UTC
fixed gnash, acroread, madwifi, pcmcia
Comment 17 Olivier Crete (RETIRED) gentoo-dev 2006-09-10 08:35:41 UTC
fixed the net-im/gossip entry
Comment 18 Alexandre Buisse (RETIRED) gentoo-dev 2006-09-10 08:50:52 UTC
Fixed dev-ml/ocamlsdl.
Comment 19 Patrick McLean gentoo-dev 2006-09-10 10:25:16 UTC
Fixed media-sound/bmpx: amazon
Comment 20 Luis Medinas (RETIRED) gentoo-dev 2006-09-10 19:17:15 UTC
beagle, banshee, bonfire and rhythmbox done.
Comment 21 Tuan Van (RETIRED) gentoo-dev 2006-09-11 09:23:39 UTC
cyrus-sasl done.
Comment 22 Daniel Gryniewicz (RETIRED) gentoo-dev 2006-09-11 18:20:20 UTC
gnome-extra/sensors-applet fixed.
Comment 23 Mike Kelly (RETIRED) gentoo-dev 2006-09-12 11:48:11 UTC
The old code that used the termcap-compat has been removed from the vim.eclass (it only affected IUSE, DEPEND, and src_compile, not anything called at unmerge). The entries have been removed from use.local.desc.
Comment 24 Jakub Moc (RETIRED) gentoo-dev 2006-09-17 04:50:24 UTC
Created attachment 97225 [details]
unused local flags (updated again)
Comment 25 Jakub Moc (RETIRED) gentoo-dev 2006-09-26 02:49:35 UTC
What's left?

app-text/poppler: use.local.desc unused flag(s): cairo
Comment 26 Stefan Schweizer (RETIRED) gentoo-dev 2006-11-18 03:13:08 UTC
there is no poppler in use.local.desc
printing fixed
Comment 27 Jakub Moc (RETIRED) gentoo-dev 2006-12-04 10:27:52 UTC
dev-db/mysql-community: use.local.desc unused flag(s): raid
media-plugins/vdr-audiorecorder: use.local.desc unused flag(s): taglib
media-video/dvdrip: use.local.desc unused flag(s): rar
media-video/vdr: use.local.desc unused flag(s): rcu, rds-timeout, vfat net-wireless/rt2x00: use.local.desc unused flag(s): eeprom
Comment 28 Joerg Bornkessel gentoo-dev 2006-12-04 11:19:24 UTC
cleanup for 

media-plugins/vdr-audiorecorder: use.local.desc unused flag(s): taglib
media-video/vdr: use.local.desc unused flag(s): rcu, rds-timeout, vfat

done ;;

Comment 29 Roy Marples (RETIRED) gentoo-dev 2006-12-04 11:40:52 UTC
Someone removed eeprom from rt2x00
Comment 30 Jakub Moc (RETIRED) gentoo-dev 2007-01-11 02:35:22 UTC
app-misc/lirc: use.local.desc unused flag(s): streamzap
dev-db/mysql: use.local.desc unused flag(s): pbxt, srvdir
dev-db/mysql-community: use.local.desc unused flag(s): raid, srvdir
dev-db/mysql-slotted: use.local.desc unused flag(s): srvdir
mail-client/mozilla-thunderbird: use.local.desc unused flag(s): mozcalendar, moznoxft
net-misc/nxserver-business: use.local.desc unused flag(s): prebuilt
net-misc/nxserver-enterprise: use.local.desc unused flag(s): prebuilt
net-misc/nxserver-personal: use.local.desc unused flag(s): prebuilt
sci-geosciences/grass: use.local.desc unused flag(s): proj
sys-apps/paludis: use.local.desc unused flag(s): gems
sys-freebsd/freebsd-bin: use.local.desc unused flag(s): rcp
xfce-base/thunar: use.local.desc unused flag(s): freetype
Comment 31 Jakub Moc (RETIRED) gentoo-dev 2007-01-28 12:47:14 UTC
dev-libs/g-wrap: use.local.desc unused flag(s) glib
net-ftp/proftpd: use.local.desc unused flag(s) sendfile
sys-cluster/util-vserver: use.local.desc unused flag(s) legacy
sys-cluster/vzctl: use.local.desc unused flag(s) udev
www-servers/tomcat: use.local.desc unused flag(s) jni
x11-base/xorg-x11: use.local.desc unused flag(s) GAPING_SECURITY_HOLE, bitmap-fonts, dlloader, dmx, font-server, insecure-drivers, sdk, truetype-fonts, type1-fonts
xfce-base/thunar: use.local.desc unused flag(s) freetype
xfce-extra/xarchiver: use.local.desc unused flag(s) ace, rpm
Comment 32 Christian Heim (RETIRED) gentoo-dev 2007-01-28 17:15:30 UTC
(In reply to comment #31)
> sys-cluster/util-vserver: use.local.desc unused flag(s) legacy
> sys-cluster/vzctl: use.local.desc unused flag(s) udev
> sys-cluster/vserver-utils: use.local.dec (no longer in the tree)

All above fixed.
Comment 33 Peter Weller (RETIRED) gentoo-dev 2007-01-31 20:13:51 UTC
All fix0rated! (The xfce ones, at least)
Comment 34 Jakub Moc (RETIRED) gentoo-dev 2007-02-02 12:19:02 UTC
The rest fixed by mr_bones
Comment 35 Jakub Moc (RETIRED) gentoo-dev 2007-05-20 13:40:47 UTC
app-cdr/cdrtools: use.local.desc unused flag(s) on-the-fly-crypt
dev-java/hibernate: use.local.desc unused flag(s) c3p0, dbcp, jboss, jcs, oscache, swarmcache
mail-client/squirrelmail: use.local.desc unused flag(s) virus-scan
media-sound/mumble: use.local.desc unused flag(s) pch
net-wireless/linux-wlan-ng-modules: use.local.desc unused flag(s) pci, plx
use.desc unused flag(s): gb, ovrimos
Comment 36 Renat Lumpau (RETIRED) gentoo-dev 2007-05-28 00:47:27 UTC
nothing to do for web-apps
Comment 37 Jakub Moc (RETIRED) gentoo-dev 2007-06-24 10:33:05 UTC
app-crypt/ccid: use.local.desc unused flag(s) chipcard2
app-editors/emacs-cvs: use.local.desc unused flag(s) aqua
dev-db/postgresql: use.local.desc unused flag(s) pg-vacuumdelay
mail-mta/qmail-ldap: use.local.desc unused flag(s) controldb
net-fs/samba: use.local.desc unused flag(s) ldapsam, libclamav
net-www/apache: use.local.desc unused flag(s) lingerd
sys-kernel/suspend2-sources: use.local.desc unused flag(s) ultra1
sys-libs/libvserver: use.local.desc unused flag(s) diet
sys-power/hibernate-script: use.local.desc unused flag(s) vim
www-client/mozilla-launcher: use.local.desc unused flag(s) aoss
Comment 38 Tiziano Müller (RETIRED) gentoo-dev 2007-06-24 12:26:42 UTC
dev-db/postgresql: use.local.desc unused flag(s) pg-hier, pg-vacuumdelay
net-fs/samba: use.local.desc unused flag(s) ldapsam, libclamav
... done
Comment 39 Ulrich Müller gentoo-dev 2007-06-24 14:47:56 UTC
app-editors/emacs-cvs: use.local.desc unused flag(s) aqua
Fixed.
Comment 40 Raúl Porcel (RETIRED) gentoo-dev 2007-06-24 14:57:26 UTC
www-client/mozilla-launcher: use.local.desc unused flag(s) aoss

Done
Comment 41 Lars Weiler (RETIRED) gentoo-dev 2007-06-24 19:34:57 UTC
(In reply to comment #35)
> app-cdr/cdrtools: use.local.desc unused flag(s) on-the-fly-crypt

Somebody must have removed that already.
Comment 42 Alon Bar-Lev (RETIRED) gentoo-dev 2007-06-25 04:42:17 UTC
Thanks! done:
sys-power/hibernate-script
app-crypt/ccid
sys-kernel/suspend2-sources
Comment 43 Christian Heim (RETIRED) gentoo-dev 2007-06-26 16:50:14 UTC
All vserver related packages were already fixed.
Comment 44 Benedikt Böhm (RETIRED) gentoo-dev 2007-07-29 22:28:37 UTC
apache related ebuilds fixed
Comment 45 Benedikt Böhm (RETIRED) gentoo-dev 2009-01-02 16:50:24 UTC
qmail-ldap already fixed
Comment 46 Roman Žilka 2013-01-23 16:23:05 UTC
I was bored today. For each global flag I made a list of packages that have at least one package version in the tree that 1. isn't masked (be it hard or ~arch) and 2. uses this flag.

$ for i in `cat use.desc |cut -d ' ' -f1`; do echo "-------- $i"; equery -Cq h -pF '$mask $cp' $i | egrep -v '(^M|~)' | sort | uniq -s 3 | tee /tmp/globals/$i; done

A tarball of the directory 'globals' is attached (please ignore the occasional dash in front of a package name). As 'wc -l' reveals, there is quite a number of flags that are used by very few packages (even zero). You might want to consider making these local flags.

Similarly, I made a list of local flags that are not global at the same time. For every such flag I counted the packages that use this flag. By "use" in this case I mean that they are listed in use.local.desc (could be masked versions of packages this time). See another attachment. Again, there are a few dozen flags that are used by >=10 packages. This is something that the user should be told about. I assume that a lot of users only notice global flags more thoroughly, because they assume that those are the ones that will matter most - affect the most packages. A similar argument supports making the scarce global flags local.

An incrementally obfuscated method for getting the second list (might need checking for errors):
# cat use.desc |cut -d ' ' -f1 > globals
# cat use.local.desc |sed 's/^[^:]*:\([^ ]*\) .*$/\1/'|sort|uniq|diff - globals |grep '^<'|cut -d ' ' -f2 |sed 's/\(.*\)/:\1 - /' >locals-that-are-not-global
# cat use.local.desc |grep -f locals-that-are-not-global |sed 's/^[^:]*:\([^ ]*\) .*$/\1/'|sort|uniq -c|sort -n >locals-that-are-not-global2
Comment 47 Roman Žilka 2013-01-23 16:24:56 UTC
Created attachment 336600 [details]
Usage of global flags by unmasked packages

Usage of global flags by unmasked packages
Comment 48 Roman Žilka 2013-01-23 16:28:05 UTC
Created attachment 336602 [details]
Usage of local-only flags by packages
Comment 49 Roman Žilka 2013-01-24 17:54:35 UTC
Created attachment 336742 [details]
Usage of global flags by unmasked packages

A better version: this time with /etc/portage/package.* removed and ACCEPT_KEYWORDS="alpha amd64 arm hppa ia64 m68k mips ppc ppc64 s390 sh sparc x86 sparc-fbsd x86-fbsd". Still, hardmasks (that are filtered out) are based on hardened amd64, where I made the lists. Might need merging with results from non-hardened x86 and perhaps ppc, but the difference won't be huge, I suppose.